w=zeros(12,3);
w(5,:)=[-1.117353329358218   0.993033742283591   0.250939278253847];
w(6,:)=[-0.4662    0.3080    0.3084];
w(7,:)=[ 0.8548   -0.7344   -0.0132];
w(8,:)=[-1.6004    1.2432    0.1763];
w(9,:)=[-0.3453    0.9829   -0.5056];
w(10,:)=[ 0.8347   -0.1639   -0.7045];
w(11,:)=[ 0.3000    1.2916   -1.3986];
w(12,:)=[ 0.1745    1.0000   -0.9239];
w(13,:)=[ 0.4550   -2.9708    2.4926];%mustapha1
w(14,:)=[-0.7808    3.3806   -2.1457];%mustapha2
w(15,:)=[-0.1003    0.8578   -0.5445];%mustapha3
w(16,:)=[-0.7695   -0.6655    1.0285];%mustapha4 (difficult)
w(17,:)=[0.1564   -0.7271    0.3012]; %ali1
w(18,:)=[-2.5103    6.2797   -3.8581];%ali2
w(19,:)=[0.2967   -0.2502   -0.3955];%serge3
w(20,:)=[-0.9275    1.2727   -0.1533];%CHU-patient-sinus1
%IUT 
w(21,:)=[ 0.011859949990826  -0.065043015249385  -0.253872679823688]; %subject012
w(22,:)=[0.540516651320267  -0.481168222078002  -0.174652535681454];%subject032
w(23,:)=[-0.205453301270746  -0.084844974392886  -0.044323508224107];%subject052
w(24,:)=[-0.970842912016807  -0.810426402060777   1.819589553520490];%subject062
w(25,:)=[0.001414297630993  -1.934196971180322   1.771656189204144];%subject072
w(26,:)=[-0.382393876687197  -1.372610226530688   1.540986984713939];%subject082
w(27,:)=[-0.167378677092908   0.124110090429041  -0.283916682518497];%subject092
w(28,:)=[0.839662061279419   2.757811600178589  -3.500803646324099];%subject102
w(29,:)=[0.052174092612632  -0.601994381299893   0.382893873333608];%subject112
w(30,:)=[0.101900757603075   0.364088521649790  -0.180593747710117];%subject122
w(31,:)=[-0.136124069686414   0.664852904434617  -0.261787173113453];%subject132
w(32,:)=[-0.223282431650697  -0.470873374486710   0.410492441249494];%subject142
w(33,:)=[0.306504757736981  -0.509703552329023  -0.031583598029828];%subject152
w(33,:)=[-0.188031506860383  -0.004641323189968  -0.168240582140901];%subject162
w(34,:)=[0.850180392563663  -0.573240590729867  -0.264150833814492];%subject172
w(35,:)=[0.181155598139213   0.957243579997182  -0.968306852985464];%subject182
w(36,:)=[ 0.044821117127121  -0.806552584120591   0.596245485356643];%subject192
w(37,:)=[0.779064444530313  -0.201502581306614  -0.657639371112457];%subject202
w(38,:)=[-0.102603609567344   0.813999082225114  -0.516411179459461];%subject212
w(39,:)=[0.502177243373008   1.035636703897971  -1.293223770379251 ];%Bad-subject222
w(40,:)=[-0.008364001289173  -1.010994480996092   0.904129297041303];%subject242

w(41,:)=[-0.763472707817890   0.761208262256045  -0.312604851665714];%Wall 
W1=w(:,1);
W2=w(:,2);
W3=w(:,3);
hold on
%xlim([-7,7]);ylim([-7,3]);zlim([-3,3]);
xlabel('R');
ylabel('G');
zlabel('B');
grid on
% for i = 5:41
%     quiver3(0,0,0,w(i,1),w(i,2),w(i,3));
%     text(w(i,1),w(i,2),w(i,3),['w' num2str(i)]);
% end
%All the above vectors lie close to a plane
%cftool
%
% Linear model Poly11:
%      f(x,y) = p00 + p10*x + p01*y
% Coefficients (with 95% confidence bounds):
%        p00 =     0.01965  (-0.06614, 0.1054)
%        p10 =     -0.8677  (-0.993, -0.7424)
%        p01 =     -0.8712  (-1.01, -0.7325)
%
% Goodness of fit:
%   SSE: 0.1
%   R-square: 0.9671
%   Adjusted R-square: 0.9598
%   RMSE: 0.1054
% Plane
X=-5:.5:5;
[x,y] = meshgrid(X);
p00 =     0.01965 ; p10 =     -0.8677 ;p01 =     -0.8712;
save('Wplane','p00','p01','p10');
z= p00 + p10*x + p01*y;
%shading flat
v=surf(x,y,z);
l=5;
[U,V,W]=surfnorm(x,y,z)
quiver3(0,0,0,l*p10,l*p10,-l,'LineWidth',2);

set(gcf,'renderer','opengl') ;
set(v,'facealpha',0.3);
axis equal
%Normal
position=[0,0,0];
normal=[l*p10,l*p10,-l];

% hold on

% for i=1:30
% tic
% randomPoint=getRandomPointInPlane(position,normal,1);
% toc
% quiver3(0,0,0,randomPoint(1),randomPoint(2),randomPoint(3),'LineWidth',2);
% pause(.1)
% end
